<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=9"/>
    <meta name="generator" content="Doxygen 1.8.11"/>
    <title>LibraryMgr: DatabaseItem&lt; T &gt; Class Template Reference</title>
    <link href="tabs.css" rel="stylesheet" type="text/css"/>
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
    <link href="navtree.css" rel="stylesheet" type="text/css"/>
    <script type="text/javascript" src="resize.js"></script>
    <script type="text/javascript" src="navtreedata.js"></script>
    <script type="text/javascript" src="navtree.js"></script>
    <script type="text/javascript">
        $(document).ready(initResizable);
        $(window).load(resizeHeight);
    </script>
    <link href="search/search.css" rel="stylesheet" type="text/css"/>
    <script type="text/javascript" src="search/searchdata.js"></script>
    <script type="text/javascript" src="search/search.js"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            init_search();
        });
    </script>
    <link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
    <div id="titlearea">
        <table cellspacing="0" cellpadding="0">
            <tbody>
            <tr style="height: 56px;">
                <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
                <td id="projectalign" style="padding-left: 0.5em;">
                    <div id="projectname">LibraryMgr
                        &#160;<span id="projectnumber">0.4</span>
                    </div>
                    <div id="projectbrief">Library manager desktop app</div>
                </td>
            </tr>
            </tbody>
        </table>
    </div>
    <!-- end header part -->
    <!-- Generated by Doxygen 1.8.11 -->
    <script type="text/javascript">
        var searchBox = new SearchBox("searchBox", "search", false, 'Search');
    </script>
    <div id="navrow1" class="tabs">
        <ul class="tablist">
            <li><a href="index.html"><span>Main&#160;Page</span></a></li>
            <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
            <li><a href="files.html"><span>Files</span></a></li>
            <li>
                <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
                 onfocus="searchBox.OnSearchFieldFocus(true)"
                 onblur="searchBox.OnSearchFieldFocus(false)"
                 onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0"
                                                                                       src="search/close.png"
                                                                                       alt=""/></a>
          </span>
                </div>
            </li>
        </ul>
    </div>
    <div id="navrow2" class="tabs2">
        <ul class="tablist">
            <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
            <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
            <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
            <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
        </ul>
    </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
    <div id="nav-tree">
        <div id="nav-tree-contents">
            <div id="nav-sync" class="sync"></div>
    </div>
    </div>
    <div id="splitbar" style="-moz-user-select:none;"
         class="ui-resizable-handle">
    </div>
</div>
<script type="text/javascript">
    $(document).ready(function () {
        initNavTree('class_database_item.html', '');
    });
</script>
<div id="doc-content">
    <!-- window showing the filter options -->
    <div id="MSearchSelectWindow"
         onmouseover="return searchBox.OnSearchSelectShow()"
         onmouseout="return searchBox.OnSearchSelectHide()"
         onkeydown="return searchBox.OnSearchSelectKey(event)">
    </div>

    <!-- iframe showing the search results (closed by default) -->
    <div id="MSearchResultsWindow">
        <iframe src="javascript:void(0)" frameborder="0"
                name="MSearchResults" id="MSearchResults">
        </iframe>
    </div>

    <div class="header">
        <div class="summary">
            <a href="#pub-methods">Public Member Functions</a> &#124;
            <a href="#friends">Friends</a> &#124;
            <a href="class_database_item-members.html">List of all members</a></div>
        <div class="headertitle">
            <div class="title">DatabaseItem&lt; T &gt; Class Template Reference</div>
        </div>
    </div><!--header-->
    <div class="contents">

        <p><code>#include &lt;<a class="el" href="_database_item_8h_source.html">DatabaseItem.h</a>&gt;</code></p>
        <table class="memberdecls">
            <tr class="heading">
                <td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
                    Public Member Functions</h2></td>
            </tr>
            <tr class="memitem:a2909c438c076478aa1c42e805b0d10ac">
                <td class="memItemLeft" align="right" valign="top">&#160;</td>
                <td class="memItemRight" valign="bottom"><a class="el"
                                                            href="class_database_item.html#a2909c438c076478aa1c42e805b0d10ac">DatabaseItem</a>
                    (T value)
                </td>
            </tr>
            <tr class="memdesc:a2909c438c076478aa1c42e805b0d10ac">
                <td class="mdescLeft">&#160;</td>
                <td class="mdescRight"><a class="el" href="class_database.html" title="Abstract collection of object. ">Database</a>
                    new database from scratch. <a href="#a2909c438c076478aa1c42e805b0d10ac">More...</a><br/></td>
            </tr>
            <tr class="separator:a2909c438c076478aa1c42e805b0d10ac">
                <td class="memSeparator" colspan="2">&#160;</td>
            </tr>
            <tr class="memitem:a1e173bac12d68b463ffe0da44cf0fd01">
                <td class="memItemLeft" align="right" valign="top">&#160;</td>
                <td class="memItemRight" valign="bottom"><a class="el"
                                                            href="class_database_item.html#a1e173bac12d68b463ffe0da44cf0fd01">DatabaseItem</a>
                    (<a class="el" href="class_database_item.html">DatabaseItem</a> &amp;d)
                </td>
            </tr>
            <tr class="memdesc:a1e173bac12d68b463ffe0da44cf0fd01">
                <td class="mdescLeft">&#160;</td>
                <td class="mdescRight"><a class="el" href="class_database_item.html">DatabaseItem</a> deep copy of
                    database. <a href="#a1e173bac12d68b463ffe0da44cf0fd01">More...</a><br/></td>
            </tr>
            <tr class="separator:a1e173bac12d68b463ffe0da44cf0fd01">
                <td class="memSeparator" colspan="2">&#160;</td>
            </tr>
            <tr class="memitem:afc5647cece99a48f944c8a6daff72f76">
                <td class="memItemLeft" align="right" valign="top"><a class="anchor"
                                                                      id="afc5647cece99a48f944c8a6daff72f76"></a>
                    &#160;</td>
                <td class="memItemRight" valign="bottom"><a class="el"
                                                            href="class_database_item.html#afc5647cece99a48f944c8a6daff72f76">~DatabaseItem</a>
                    ()
                </td>
            </tr>
            <tr class="memdesc:afc5647cece99a48f944c8a6daff72f76">
                <td class="mdescLeft">&#160;</td>
                <td class="mdescRight">~DatabaseItem delete database item <br/></td>
            </tr>
            <tr class="separator:afc5647cece99a48f944c8a6daff72f76">
                <td class="memSeparator" colspan="2">&#160;</td>
            </tr>
            <tr class="memitem:a58fae12dad2ba8fa7447c69b0897b86c">
                <td class="memItemLeft" align="right" valign="top">bool&#160;</td>
                <td class="memItemRight" valign="bottom"><a class="el"
                                                            href="class_database_item.html#a58fae12dad2ba8fa7447c69b0897b86c">operator==</a>
                    (const <a class="el" href="class_database_item.html">DatabaseItem</a> &amp;other) const
                </td>
            </tr>
            <tr class="memdesc:a58fae12dad2ba8fa7447c69b0897b86c">
                <td class="mdescLeft">&#160;</td>
                <td class="mdescRight">equals other item <a href="#a58fae12dad2ba8fa7447c69b0897b86c">More...</a><br/>
                </td>
            </tr>
            <tr class="separator:a58fae12dad2ba8fa7447c69b0897b86c">
                <td class="memSeparator" colspan="2">&#160;</td>
            </tr>
        </table>
        <table class="memberdecls">
            <tr class="heading">
                <td colspan="2"><h2 class="groupheader"><a name="friends"></a>
                    Friends</h2></td>
            </tr>
            <tr class="memitem:af68fc3cdc39ccceb062d7b4daea86ce9">
                <td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td>
                <td class="memItemRight" valign="bottom"><a class="el"
                                                            href="class_database_item.html#af68fc3cdc39ccceb062d7b4daea86ce9">operator&lt;&lt;</a>
                    (std::ostream &amp;out, const <a class="el" href="class_database_item.html">DatabaseItem</a>&lt; T
                    &gt; &amp;databaseItem)
                </td>
            </tr>
            <tr class="memdesc:af68fc3cdc39ccceb062d7b4daea86ce9">
                <td class="mdescLeft">&#160;</td>
                <td class="mdescRight">operator &lt;&lt; printer <a
                        href="#af68fc3cdc39ccceb062d7b4daea86ce9">More...</a><br/></td>
            </tr>
            <tr class="separator:af68fc3cdc39ccceb062d7b4daea86ce9">
                <td class="memSeparator" colspan="2">&#160;</td>
            </tr>
        </table>
        <a name="details" id="details"></a>
        <h2 class="groupheader">Detailed Description</h2>
        <div class="textblock"><h3>template&lt;class T&gt;<br/>
            class DatabaseItem&lt; T &gt;</h3>

            <p>Copyright 2016-2017 Stefano Fogarollo</p>
            <p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in
                compliance with the License. You may obtain a copy of the License at</p>
            <p><a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a></p>
            <p>Unless required by applicable law or agreed to in writing, software distributed under the License is
                distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
                implied. See the License for the specific language governing permissions and limitations under the
                License. General item to be in a <a class="el" href="class_database.html"
                                                    title="Abstract collection of object. ">Database</a></p>
        </div>
        <h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
        <a class="anchor" id="a2909c438c076478aa1c42e805b0d10ac"></a>
        <div class="memitem">
            <div class="memproto">
                <div class="memtemplate">
                    template&lt;class T &gt; </div>
                <table class="mlabels">
                    <tr>
                        <td class="mlabels-left">
                            <table class="memname">
                                <tr>
                                    <td class="memname"><a class="el" href="class_database_item.html">DatabaseItem</a>&lt;
                                        T &gt;::<a class="el" href="class_database_item.html">DatabaseItem</a></td>
                                    <td>(</td>
                                    <td class="paramtype">T&#160;</td>
                                    <td class="paramname"><em>value</em></td>
                                    <td>)</td>
                                    <td></td>
                                </tr>
                            </table>
                        </td>
                        <td class="mlabels-right">
                            <span class="mlabels"><span class="mlabel">inline</span></span></td>
                    </tr>
                </table>
            </div>
            <div class="memdoc">

                <p><a class="el" href="class_database.html" title="Abstract collection of object. ">Database</a> new
                    database from scratch. </p>
                <dl class="params">
                    <dt>Parameters</dt>
                    <dd>
                        <table class="params">
                            <tr>
                                <td class="paramname">value</td>
                                <td>value of database item</td>
                            </tr>
                        </table>
                    </dd>
                </dl>
                <dl class="section return">
                    <dt>Returns</dt>
                    <dd>new item of database</dd>
                </dl>

            </div>
        </div>
        <a class="anchor" id="a1e173bac12d68b463ffe0da44cf0fd01"></a>
        <div class="memitem">
            <div class="memproto">
                <div class="memtemplate">
                    template&lt;class T &gt; </div>
                <table class="mlabels">
                    <tr>
                        <td class="mlabels-left">
                            <table class="memname">
                                <tr>
                                    <td class="memname"><a class="el" href="class_database_item.html">DatabaseItem</a>&lt;
                                        T &gt;::<a class="el" href="class_database_item.html">DatabaseItem</a></td>
                                    <td>(</td>
                                    <td class="paramtype"><a class="el" href="class_database_item.html">DatabaseItem</a>&lt;
                                        T &gt; &amp;&#160;</td>
                                    <td class="paramname"><em>d</em></td>
                                    <td>)</td>
                                    <td></td>
                                </tr>
                            </table>
                        </td>
                        <td class="mlabels-right">
                            <span class="mlabels"><span class="mlabel">inline</span></span></td>
                    </tr>
                </table>
            </div>
            <div class="memdoc">

                <p><a class="el" href="class_database_item.html">DatabaseItem</a> deep copy of database. </p>
                <dl class="params">
                    <dt>Parameters</dt>
                    <dd>
                        <table class="params">
                            <tr>
                                <td class="paramname">d</td>
                                <td>database item to copy</td>
                            </tr>
                        </table>
                    </dd>
                </dl>
                <dl class="section return">
                    <dt>Returns</dt>
                    <dd>new item of database</dd>
                </dl>

            </div>
        </div>
        <h2 class="groupheader">Member Function Documentation</h2>
        <a class="anchor" id="a58fae12dad2ba8fa7447c69b0897b86c"></a>
        <div class="memitem">
            <div class="memproto">
                <div class="memtemplate">
                    template&lt;class T &gt; </div>
                <table class="mlabels">
                    <tr>
                        <td class="mlabels-left">
                            <table class="memname">
                                <tr>
                                    <td class="memname">bool <a class="el"
                                                                href="class_database_item.html">DatabaseItem</a>&lt; T
                                        &gt;::operator==
                                    </td>
                                    <td>(</td>
                                    <td class="paramtype">const <a class="el" href="class_database_item.html">DatabaseItem</a>&lt;
                                        T &gt; &amp;&#160;</td>
                                    <td class="paramname"><em>other</em></td>
                                    <td>)</td>
                                    <td> const</td>
                                </tr>
                            </table>
                        </td>
                        <td class="mlabels-right">
                            <span class="mlabels"><span class="mlabel">inline</span></span></td>
                    </tr>
                </table>
            </div>
            <div class="memdoc">

                <p>equals other item </p>
                <dl class="params">
                    <dt>Parameters</dt>
                    <dd>
                        <table class="params">
                            <tr>
                                <td class="paramname">other</td>
                                <td>other object to compare with</td>
                            </tr>
                        </table>
                    </dd>
                </dl>
                <dl class="section return">
                    <dt>Returns</dt>
                    <dd>true iff 2 items are the same</dd>
                </dl>

            </div>
        </div>
        <h2 class="groupheader">Friends And Related Function Documentation</h2>
        <a class="anchor" id="af68fc3cdc39ccceb062d7b4daea86ce9"></a>
        <div class="memitem">
            <div class="memproto">
                <div class="memtemplate">
                    template&lt;class T &gt; </div>
                <table class="mlabels">
                    <tr>
                        <td class="mlabels-left">
                            <table class="memname">
                                <tr>
                                    <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
                                    <td>(</td>
                                    <td class="paramtype">std::ostream &amp;&#160;</td>
                                    <td class="paramname"><em>out</em>,</td>
                                </tr>
                                <tr>
                                    <td class="paramkey"></td>
                                    <td></td>
                                    <td class="paramtype">const <a class="el" href="class_database_item.html">DatabaseItem</a>&lt;
                                        T &gt; &amp;&#160;</td>
                                    <td class="paramname"><em>databaseItem</em>&#160;</td>
                                </tr>
                                <tr>
                                    <td></td>
                                    <td>)</td>
                                    <td></td>
                                    <td></td>
                                </tr>
                            </table>
                        </td>
                        <td class="mlabels-right">
                            <span class="mlabels"><span class="mlabel">friend</span></span></td>
                    </tr>
                </table>
            </div>
            <div class="memdoc">

                <p>operator &lt;&lt; printer </p>
                <dl class="params">
                    <dt>Parameters</dt>
                    <dd>
                        <table class="params">
                            <tr>
                                <td class="paramname">out</td>
                                <td>stream</td>
                            </tr>
                            <tr>
                                <td class="paramname">object</td>
                                <td>to print</td>
                            </tr>
                        </table>
                    </dd>
                </dl>
                <dl class="section return">
                    <dt>Returns</dt>
                    <dd>print object</dd>
                </dl>

            </div>
        </div>
        <hr/>
        The documentation for this class was generated from the following file:
        <ul>
            <li>models/Database/DatabaseItem/<a class="el" href="_database_item_8h_source.html">DatabaseItem.h</a></li>
        </ul>
    </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
    <ul>
        <li class="navelem"><a class="el" href="class_database_item.html">DatabaseItem</a></li>
        <li class="footer">Generated by
            <a href="http://www.doxygen.org/index.html">
                <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11
        </li>
    </ul>
</div>
</body>
</html>
